/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_MeasurementOrientation;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_MeasurementOrientation;
import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumChestCardiacSNOMEDMap;

/**
 * This class represents MeasurementOrientation CID12118
 */
public class MeasurementOrientation_CID12118 {

	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new MeasurementOrientation_CID12118 Template 
	 */
	public MeasurementOrientation_CID12118()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumMeasurementOrientation Object of EnumCM_MeasurementOrientation represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_MeasurementOrientation enumMeasurementOrientation)
	{
		switch(enumMeasurementOrientation) 
		{
		case ANTERIOR_POSTERIOR: this.strCodeValue =EnumCV_MeasurementOrientation.ANTERIOR_POSTERIOR_122675.getValue(); break;
		case TRANSVERSE: this.strCodeValue =EnumCV_MeasurementOrientation.TRANSVERSE_G_A117.getValue(); break;
		case LONGITUDINAL: this.strCodeValue =EnumCV_MeasurementOrientation.LONGITUDINAL_G_A143.getValue(); break;
		}
	}

	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumMeasurementOrientation Object of EnumCM_MeasurementOrientation represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_MeasurementOrientation enumMeasurementOrientation)
	{
		switch(enumMeasurementOrientation)
		{
		case TRANSVERSE : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.TRANSVERSE.getSNOMEDCTID(); break;
		case LONGITUDINAL : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.LONGITUDINAL.getSNOMEDCTID(); break;
		}
	}

	/**
	 * Sets the value for MeasurementOrientation
	 * @param enumMeasurementOrientation Object of EnumCM_MeasurementOrientation.
	 */
	public void setMeasurementOrientation(EnumCM_MeasurementOrientation enumMeasurementOrientation)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumMeasurementOrientation.getValue();
		if(this.strCodeMeaning.equalsIgnoreCase(EnumCM_MeasurementOrientation.ANTERIOR_POSTERIOR.getValue()))
				this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.DCM.getValue();
			else
				this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumMeasurementOrientation);

		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumMeasurementOrientation);
	}
}
